<?php
// ******************************************************* //
//
// ©2013 SmugWimp
//
// As always, Mi Script, Su Script. Have at it. Just play nice, ok?
//
// Available exclusively from Buzztouchmods.com, the Source for BT Source.
// 
// Smug Redirector extends the possiblities of the API Saver
// 
// It will allow you to send a page request to your server
// rather than a direct link from your device app software.
// 
// This will allow you to gather statistics about the use of your app
// but the functionality will be transparent to the user.
// 
// Similar to the API Saver, It will retrieve and cache API Driven URL's
// but adds the data gathering functionality you've wanted.
// 
// Rather than a cumbersome SQL Database, we've opted for a simple
// comma delimted text file for extremely simple imports to anything.
// 
// ******************************************************* //
// $logfile will be closed out every hour and saved.
// $logfile format will be csv
// $logfile will be named <youChooseTheFilename>Log_YYYYMMDD.txt
// $dataFile will be named <youChooseTheFilename>_YYYYMMDD.txt
//
// You only have to provide two variables;
// 1) Your desired data filename prefix
// 2) Your distant end API URL
//
// In your BT control Panel, your URL is appended by the datafields you desire.
// 
// These are your available fields.
// 
//  "BTApp" [buzztouchAppId] This is the App Id from your buzztouch control panel
//  "BTApi" [buzztouchAPIKey] This is the app API Key from your buzztouch control panel
//  "BTS"   [screenId] The unique id of the current screen (useful for determing the app context)
//  "BTU"   [userId] The Unique Id of a logged in user (if the app uses login screens)
//  "BTE"   [userEmail] The email address of a logged in user
//  "BTD"   [deviceId] A globally unique string value assigned to the device.
//  "BTM"   [deviceModel] A string value controlled by the device manufacturer.
//  "BTLat" [deviceLatitude] A latitude coordinate value (if the device is reporting it's location).
//  "BTLon" [deviceLongitude] A longitude coordinate value (if the device is reporting it's location).
//
// We also include:
// Current Date
// Current Time (as referenced from the server, not the client) 
// Device IP Address.
// Device Browser Client
//
// A crafty person could determine date/time of the client by server date/time and 
// client geo coordinates and subtracting/adding time zones.
//
// A Field Header and Column will exist whether the variable is used or not.
//
// http://www.yourserver.com?BTApp=[buzztouchAppId]&BTApi=[buzztouchAPIKey]&BTS=[screenId]&BTU=[userId]&BTE=[userEmail]&BTD=[deviceId]&BTM=[deviceModel]&BTLat=[deviceLatitude]&BTLon=[deviceLongitude]
//
// ******************************************************* //
// *********** Change These Values as desired ************ //
// ******************************************************* //
//
// this will be the name of your data file; 1 new each hour.
// for example: weather_03.txt
// your logfile would be (for example) named weatherLog_03.txt
//
// do not add 'Log' or '_' to the filenames; they're already there.
// 
	$filenameprefix = "weather";
//
// this is your dataURL field.
//
	$URLString = "http://api.worldweatheronline.com/free/v1/weather.ashx?q=13.500000,144.800000&format=json&num_of_days=5&key=7yxsuzse2b7b3z6qxx4728br";
//
// Use "0" for cached data; one datafile per hour.
// Use "1" for no cached data file (constant refresh)
// Use "2" for no file deletion (data archive mode)
//
	$DataMode = "0";
//
// ******************************************************* //
// *********** Change Nothing Below This Line ************ //
// ******************************************************* //
//														   //
$BTDate = date("Y-m-d");
$BTTime = date("H:i:s");
$BTIPAddr = $_SERVER['REMOTE_ADDR'];
$BTBrow = $_SERVER['HTTP_USER_AGENT'];
$BTApp = $_GET["BTApp"];
$BTApi = $_GET["BTApi"];
$BTS = $_GET["BTS"];
$BTU = $_GET["BTU"];
$BTE = $_GET["BTE"];
$BTD = $_GET["BTD"];
$BTM = $_GET["BTM"];
$BTLat = $_GET["BTLat"];
$BTLon = $_GET["BTLon"];
$DBFields = "BTDate,BTTime,BTIPAddr,BTBrow,BT App,BTApi,BTS,BTU,BTE,BTD,BTM,BTLat,BTLon";
$DBString = $BTDate . "," . $BTTime . "," . $BTIPAddr . "," . $BTBrow . "," . $BTApp . "," . $BTApi . "," . $BTS . "," . $BTU . "," . $BTE . "," . $BTD . "," . $BTM . "," . $BTLat . "," . $BTLon;
$swLogFile = $filenameprefix . "Log_" . date('YmdH') . ".txt";
$swFileName = $filenameprefix . "_" . date('YmdH') . ".txt"; // default filename
//////////////////////////////////////////////////////////////////////
if (file_exists($swLogFile)) { // if the default filename exists...
	$success = file_put_contents($swLogFile, $DBString . "\n", FILE_APPEND | LOCK_EX); 
} else { // else it does not exist... must be the first new user of the hour
	$success = file_put_contents($swLogFile, $DBFields . "\n", FILE_APPEND | LOCK_EX); 
	$success = file_put_contents($swLogFile, $DBString . "\n", FILE_APPEND | LOCK_EX); 
} 
if (file_exists($swFileName)) { // does the default filename exist?
	ob_clean();  // if so, flush the most recent cache
	flush();     // so no old data gets out to the client...
	readfile($swFileName); // and feed them the most current file
} else { // else it does not exist... must be the first new user of the hour
	// so create a new file, name it our default name, and use the URL data for the contents...
	$success = file_put_contents($swFileName, file_get_contents($URLString)); 
	// the new file is saved as the new default filename and..
	ob_clean(); // flush the most recent cache
	flush();    // so no old data gets out to the client...
	readfile($swFileName); // and feed them the most current file
} 

switch ($DataMode)
{
case "0":
	$dir = @ opendir("./");
	while (($file = readdir($dir)) !== false) {
		if (fnmatch($filenameprefix . "_" . date('YmdH') . "*", $file)) {
	//		echo("It Is");
		} else {
	//		echo("It Isn't");
			if (fnmatch($filenameprefix . "_*", $file)) { // if it's a weather file, but not our current weather file, delete it.			
				unlink($file);
			}
		}
	}
  break;
case "1":
	$dir = @ opendir("./");
	while (($file = readdir($dir)) !== false)
	  {
	  	if (fnmatch($filenameprefix . "_", $file)) { // if it's a weather file delete it.			
			unlink($file);
		}
	  }
	closedir($dir);
  break;
case "2":
  break;
}